commit 910156619c93ff988587762b446542c4dfbb00a2
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Oct 19 22:37:56 2022 +0200

    Fortran: error recovery with references of bad array constructors [PR105633]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/105633
            * expr.c (find_array_section): Move check for NULL pointers so
            that both subscript triplets and vector subscripts are covered.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/105633
            * gfortran.dg/pr105633.f90: New test.
    
    Co-authored-by: Steven G. Kargl <kargl@gcc.gnu.org>
    (cherry picked from commit ecb20df4fa6d99daa635c7fb662dc0554610777e)

diff --git a/gcc/fortran/expr.c b/gcc/fortran/expr.c
index 1129f5f3302..b65fc764fb8 100644
--- a/gcc/fortran/expr.c
+++ b/gcc/fortran/expr.c
@@ -1549,6 +1549,12 @@ find_array_section (gfc_expr *expr, gfc_ref *ref)
       lower = ref->u.ar.as->lower[d];
       upper = ref->u.ar.as->upper[d];
 
+      if (!lower || !upper)
+	{
+	  t = false;
+	  goto cleanup;
+	}
+
       if (ref->u.ar.dimen_type[d] == DIMEN_VECTOR)  /* Vector subscript.  */
 	{
 	  gfc_constructor *ci;
@@ -1591,9 +1597,7 @@ find_array_section (gfc_expr *expr, gfc_ref *ref)
 	{
 	  if ((begin && begin->expr_type != EXPR_CONSTANT)
 	      || (finish && finish->expr_type != EXPR_CONSTANT)
-	      || (step && step->expr_type != EXPR_CONSTANT)
-	      || !lower
-	      || !upper)
+	      || (step && step->expr_type != EXPR_CONSTANT))
 	    {
 	      t = false;
 	      goto cleanup;
diff --git a/gcc/testsuite/gfortran.dg/pr105633.f90 b/gcc/testsuite/gfortran.dg/pr105633.f90
new file mode 100644
index 00000000000..f2dbc5e742a
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr105633.f90
@@ -0,0 +1,8 @@
+! { dg-do compile }
+! PR fortran/105633 - ICE in find_array_section
+! Contributed by G.Steinmetz
+
+program p
+  integer, parameter :: a(:) = [1,2] ! { dg-error "deferred shape" }
+  print *, [a([1,2])]
+end

